<?php

/**
 * @file
 * Add an email address.
 */

namespace Drupal\dream_fields\Plugin\DreamField;


/**
 * Plugin implementation of 'email'.
 *
 * @DreamField(
 *   id = "email",
 *   label = @Translation("Email address"),
 *   description = @Translation("This will add an input field for an email address and will be outputted with a link."),
 *   preview = "images/textfield-dreamfields.png",
 *   field_types = {
 *     "email"
 *   },
 * )
 */
class DreamFieldEmail extends \Drupal\dream_fields\DreamFieldPluginBase {

  /**
   * {@inheritdoc}
   */
  public function getForm() {
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm() {
  }

  /**
   * {@inheritdoc}
   */
  public function saveForm($label, $required, $values, $entityTypeId, $bundle) {
    $this->field_name = $this->createFieldMachineName($label);
    $this->widget_id = 'email_default';
    $this->entityTypeId = $entityTypeId;
    $this->bundle = $bundle;

    $this->field_storage_values = [
      'type' => 'email',
    ];

    $this->field_values = [
      'label' => $label,
      'required' => $required,
    ];

    $this->field_display_values = [
      'type' => 'email_mailto',
      'label' => 'inline',
    ];

    $this->createFieldStorageAndField();
  }

}
