<?php

/**
 * @file
 * Add a link.
 */

namespace Drupal\dream_fields\Plugin\DreamField;


/**
 * Plugin implementation of 'link'.
 *
 * @DreamField(
 *   id = "link",
 *   label = @Translation("Link"),
 *   description = @Translation("This will add an input field for an internal or external URL and will be outputted with the label in the front."),
 *   preview = "images/textfield-dreamfields.png",
 *   field_types = {
 *     "link"
 *   },
 * )
 */
class DreamFieldLink extends \Drupal\dream_fields\DreamFieldPluginBase {

  /**
   * {@inheritdoc}
   */
  public function getForm() {
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm() {
  }

  /**
   * {@inheritdoc}
   */
  public function saveForm($label, $required, $values, $entityTypeId, $bundle) {
    $this->field_name = $this->createFieldMachineName($label);
    $this->widget_id = 'link_default';
    $this->entityTypeId = $entityTypeId;
    $this->bundle = $bundle;

    $this->field_storage_values = [
      'type' => 'link',
    ];

    $this->field_values = [
      'label' => $label,
      'required' => $required,
    ];

    $this->field_display_values = [
      'type' => 'link',
      'label' => 'inline',
      'settings' => [
        'trim_length' => NULL,
        'url_only' => FALSE,
        'url_plain' => FALSE,
        'rel' => '0',
        'target' => '0',
      ],
    ];

    $this->createFieldStorageAndField();
  }

}
