<?php

/**
 * @file
 * Add a list of checkboxes.
 */

namespace Drupal\dream_fields\Plugin\DreamField;


/**
 * Plugin implementation of 'list_checkbox'.
 *
 * @DreamField(
 *   id = "list_checkbox",
 *   label = @Translation("List of checkboxes"),
 *   description = @Translation("This will add a list of checkboxes, the labels of each checkbox can be defined below and will be outputted with the label at the top."),
 *   preview = "images/checkboxes-dreamfields.png",
 * )
 */
class DreamFieldListCheckbox extends DreamFieldList {

  /**
   * {@inheritdoc}
   */
  public function getForm() {
    return parent::buildForm('list_checkbox');
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm() {
  }

  /**
   * {@inheritdoc}
   */
  public function saveForm($label, $required, $values, $entityTypeId, $bundle) {
    $this->widget_id = 'options_buttons';
    $this->cardinality = \Drupal\Core\Field\FieldStorageDefinitionInterface::CARDINALITY_UNLIMITED;

    $this->field_display_values = [
      'label' => 'above',
    ];

    parent::saveForm($label, $required, $values, $entityTypeId, $bundle);
  }

}
