<?php

/**
 * @file
 * Add a list of radio buttons.
 */

namespace Drupal\dream_fields\Plugin\DreamField;


/**
 * Plugin implementation of 'list_radio'.
 *
 * @DreamField(
 *   id = "list_radio",
 *   label = @Translation("List of radio items"),
 *   description = @Translation("This will add a list of radio buttons, the labels for each button can be defined below and it will be outputted it with the label at the top."),
 *   preview = "images/checkboxes-dreamfields.png",
 * )
 */
class DreamFieldListRadio extends DreamFieldList {

  /**
   * {@inheritdoc}
   */
  public function getForm() {
    return parent::buildForm('list_radio');
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm() {
  }

  /**
   * {@inheritdoc}
   */
  public function saveForm($label, $required, $values, $entityTypeId, $bundle) {
    $this->widget_id = 'options_buttons';
    $this->cardinality = 1;
    parent::saveForm($label, $required, $values, $entityTypeId, $bundle);
  }

}
