<?php

/**
 * @file
 * Add a dropdown list.
 */

namespace Drupal\dream_fields\Plugin\DreamField;


/**
 * Plugin implementation of 'list_select'.
 *
 * @DreamField(
 *   id = "list_select",
 *   label = @Translation("Dropdown list"),
 *   description = @Translation("This will add a dropdown list, the options can be defined below and it will be outputted with the label in the front."),
 *   preview = "images/selectbox-dreamfields.png",
 * )
 */
class DreamFieldListSelect extends DreamFieldList {

  /**
   * {@inheritdoc}
   */
  public function getForm() {
    return parent::buildForm('list_select');
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm() {
  }

  /**
   * {@inheritdoc}
   */
  public function saveForm($label, $required, $values, $entityTypeId, $bundle) {
    $this->widget_id = 'options_select';
    $this->cardinality = 1;
    parent::saveForm($label, $required, $values, $entityTypeId, $bundle);
  }

}
