<?php

/**
 * @file
 * Add a multiline text field.
 */

namespace Drupal\dream_fields\Plugin\DreamField;


/**
 * Plugin implementation of 'text_long'.
 *
 * @DreamField(
 *   id = "text_long",
 *   label = @Translation("Multiples lines of text"),
 *   description = @Translation("This will add an input field for multiple lines of text and will be outputted with the label at the top."),
 *   preview = "images/textarea-dreamfields.png",
 * )
 */
class DreamFieldStringMulti extends \Drupal\dream_fields\DreamFieldPluginBase {
  /**
   * {@inheritdoc}
   */
  public function getForm() {
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm() {
  }

  /**
   * {@inheritdoc}
   */
  public function saveForm($label, $required, $values, $entityTypeId, $bundle) {
    $this->field_name = $this->createFieldMachineName($label);
    $this->widget_id = 'string_textarea';
    $this->entityTypeId = $entityTypeId;
    $this->bundle = $bundle;

    $this->field_storage_values = [
      'field_name' => $this->field_name,
      'entity_type' => $entityTypeId,
      'type' => 'string_long',
      'translatable' => TRUE,
      'cardinality' => 1,
      'settings' => [],
    ];
    $this->field_values = [
      'field_name' => $this->field_name,
      'entity_type' => $entityTypeId,
      'bundle' => $bundle,
      'label' => $label,
      'translatable' => FALSE,
      'required' => $required,
      'settings' => [],
    ];
    $this->field_display_values = [
      'label' => 'hidden',
    ];

    $this->createFieldStorageAndField();
  }

}
