<?php

/**
 * @file
 * Add a single line of text.
 */

namespace Drupal\dream_fields\Plugin\DreamField;


/**
 * Plugin implementation of 'text_single'.
 *
 * @DreamField(
 *   id = "text_single",
 *   label = @Translation("Single line of text"),
 *   description = @Translation("This will add an input field for a single line of text and will be outputted with the label in the front."),
 *   preview = "images/textfield-dreamfields.png",
 * )
 */
class DreamFieldStringSingle extends \Drupal\dream_fields\DreamFieldPluginBase {

  /**
   * {@inheritdoc}
   */
  public function getForm() {
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm() {
  }

  /**
   * {@inheritdoc}
   */
  public function saveForm($label, $required, $values, $entityTypeId, $bundle) {
    $this->field_name = $this->createFieldMachineName($label);
    $this->widget_id = 'string_textfield';
    $this->entityTypeId = $entityTypeId;
    $this->bundle = $bundle;

    $this->field_storage_values = [
      'field_name' => $this->field_name,
      'entity_type' => $entityTypeId,
      'type' => 'string',
      'translatable' => TRUE,
      'cardinality' => 1,
      'settings' => [],
    ];

    $this->field_values = [
      'field_name' => $this->field_name,
      'entity_type' => $entityTypeId,
      'bundle' => $bundle,
      'label' => $label,
      'translatable' => FALSE,
      'required' => $required,
      'settings' => [],
    ];
    $this->field_display_values = [
      'label' => 'inline',
    ];

    $this->createFieldStorageAndField();
  }

}
